Backend API
import React from 'react';
import DataGrid, {
Column, Editing, Grouping, GroupPanel, Pager, Paging, ColumnChooser,
} from 'devextreme-react/data-grid';
import { orders } from './data.ts';
const allowedPageSizes = [5, 8, 15, 30];
const App = () => (
<div>
<DataGrid
id="gridContainer"
dataSource={orders}
keyExpr="ID"
columnHidingEnabled={true}
width="100%"
showBorders={true}>
<Editing allowAdding={true} allowUpdating={true} mode="batch" />
<Grouping contextMenuEnabled={true} expandMode="rowClick" />
<GroupPanel visible={true} emptyPanelText="Use the context menu of header columns to group data" />
<Pager
allowedPageSizes={allowedPageSizes}
showInfo={true}
showNavigationButtons={true}
showPageSizeSelector={true}
visible={true} />
<Paging defaultPageSize={8} />
<ColumnChooser enabled={true} mode="select" />
<Column allowGrouping={false} dataField="OrderNumber" width={130} caption="Invoice Number" />
<Column dataField="CustomerStoreCity" caption="City" />
<Column dataField="CustomerStoreState" caption="State" />
<Column dataField="Employee" />
<Column dataField="OrderDate" dataType="date" />
<Column dataField="SaleAmount" format="currency" />
</DataGrid>
</div>
);
export default App;
import React from 'react';
import DataGrid, {
Column,
Editing,
Grouping,
GroupPanel,
Pager,
Paging,
ColumnChooser,
} from 'devextreme-react/data-grid';
import { orders } from './data.js';
const allowedPageSizes = [5, 8, 15, 30];
const App = () => (
<div>
<DataGrid
id="gridContainer"
dataSource={orders}
keyExpr="ID"
columnHidingEnabled={true}
width="100%"
showBorders={true}
>
<Editing
allowAdding={true}
allowUpdating={true}
mode="batch"
/>
<Grouping
contextMenuEnabled={true}
expandMode="rowClick"
/>
<GroupPanel
visible={true}
emptyPanelText="Use the context menu of header columns to group data"
/>
<Pager
allowedPageSizes={allowedPageSizes}
showInfo={true}
showNavigationButtons={true}
showPageSizeSelector={true}
visible={true}
/>
<Paging defaultPageSize={8} />
<ColumnChooser
enabled={true}
mode="select"
/>
<Column
allowGrouping={false}
dataField="OrderNumber"
width={130}
caption="Invoice Number"
/>
<Column
dataField="CustomerStoreCity"
caption="City"
/>
<Column
dataField="CustomerStoreState"
caption="State"
/>
<Column dataField="Employee" />
<Column
dataField="OrderDate"
dataType="date"
/>
<Column
dataField="SaleAmount"
format="currency"
/>
</DataGrid>
</div>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: '2024/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: '2024/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: '2024/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2023/12/31',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: '2024/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: '2024/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: '2024/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: '2024/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const orders = [
{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
},
{
ID: 9,
OrderNumber: 36987,
OrderDate: '2024/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 19,
OrderNumber: 43982,
OrderDate: '2024/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 29,
OrderNumber: 56272,
OrderDate: '2024/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 30,
OrderNumber: 57429,
OrderDate: '2023/12/31',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
{
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 40,
OrderNumber: 66947,
OrderDate: '2024/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
},
{
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
},
{
ID: 50,
OrderNumber: 76927,
OrderDate: '2024/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
{
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
},
{
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 60,
OrderNumber: 88027,
OrderDate: '2024/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 70,
OrderNumber: 99247,
OrderDate: '2024/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
},
{
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
{
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
},
{
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
},
{
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
},
{
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
},
{
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
padding: 10px;
}

Backend API
<template>
<div>
<DxDataGrid
id="gridContainer"
:data-source="orders"
:key-expr="'ID'"
:column-hiding-enabled="true"
:width="'100%'"
:show-borders="true"
>
<DxEditing
:allow-adding="true"
:allow-updating="true"
mode="batch"
/>
<DxGrouping
:context-menu-enabled="true"
expand-mode="rowClick"
/>
<DxGroupPanel
:visible="true"
empty-panel-text="Use the context menu of header columns to group data"
/>
<DxPager
:allowed-page-sizes="[5, 8, 15, 30]"
:show-info="true"
:show-navigation-buttons="true"
:show-page-size-selector="true"
:visible="true"
/>
<DxPaging :page-size="8"/>
<DxColumnChooser
:enabled="true"
mode="select"
/>
<DxColumn
:allow-grouping="false"
:width="130"
data-field="OrderNumber"
caption="Invoice Number"
/>
<DxColumn
data-field="CustomerStoreCity"
caption="City"
/>
<DxColumn
data-field="CustomerStoreState"
caption="State"
/>
<DxColumn data-field="Employee"/>
<DxColumn
data-field="OrderDate"
data-type="date"
/>
<DxColumn
data-field="SaleAmount"
format="currency"
/>
</DxDataGrid>
</div>
</template>
<script setup lang="ts">
import {
DxDataGrid,
DxColumn,
DxEditing,
DxGrouping,
DxGroupPanel,
DxPager,
DxPaging,
DxColumnChooser,
} from 'devextreme-vue/data-grid';
import { orders } from './data.ts';
</script>
<style scoped>
#gridContainer {
padding: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export type Order = {
ID: number;
OrderNumber: number;
OrderDate: string;
SaleAmount: number;
Terms: string;
CustomerStoreState: string;
CustomerStoreCity: string;
Employee: string;
};
export const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: '2024/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: '2024/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: '2024/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2023/12/31',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: '2024/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: '2024/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: '2024/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: '2024/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
<dx-data-grid
id="gridContainer"
[dataSource]="dataSource"
[keyExpr]="'ID'"
[width]="'100%'"
[columnHidingEnabled]="true"
[showBorders]="true"
>
<dxo-data-grid-editing
[allowAdding]="true"
[allowUpdating]="true"
mode="batch"
></dxo-data-grid-editing>
<dxo-data-grid-grouping
[contextMenuEnabled]="true"
expandMode="rowClick"
></dxo-data-grid-grouping>
<dxo-data-grid-group-panel
[visible]="true"
emptyPanelText="Use the context menu of header columns to group data"
></dxo-data-grid-group-panel>
<dxo-data-grid-pager
[allowedPageSizes]="[5, 8, 15, 30]"
[showInfo]="true"
[showNavigationButtons]="true"
[showPageSizeSelector]="true"
[visible]="true"
>
</dxo-data-grid-pager>
<dxo-data-grid-paging [pageSize]="8"></dxo-data-grid-paging>
<dxo-data-grid-column-chooser
[enabled]="true"
mode="select"
></dxo-data-grid-column-chooser>
<dxi-data-grid-column
[allowGrouping]="false"
dataField="OrderNumber"
[width]="130"
caption="Invoice Number"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="CustomerStoreCity"
caption="City"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="CustomerStoreState"
caption="State"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="Employee"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="OrderDate"
dataType="date"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="SaleAmount"
format="currency"
></dxi-data-grid-column>
</dx-data-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxDataGridModule } from 'devextreme-angular';
import { Service, Order } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxDataGridModule,
],
})
export class AppComponent {
dataSource: Order[];
constructor(service: Service) {
this.dataSource = service.getOrders();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #gridContainer {
padding: 10px;
}
import { Injectable } from '@angular/core';
export class Order {
ID: number;
OrderNumber: number;
OrderDate: string;
SaleAmount: number;
Terms: string;
CustomerStoreState: string;
CustomerStoreCity: string;
Employee: string;
}
const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: '2024/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: '2024/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: '2024/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2023/12/31',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: '2024/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: '2024/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: '2024/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: '2024/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
@Injectable()
export class Service {
getOrders() {
return orders;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>